package com.onkie.HomeSwitch;

import android.app.Activity;
import android.content.Context;
import android.hardware.usb.UsbManager;
import android.os.Bundle;
import android.os.Environment;
import android.view.View;
import android.widget.*;
import com.hoho.android.usbserial.driver.UsbSerialDriver;
import com.hoho.android.usbserial.driver.UsbSerialProber;

import java.io.*;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Locale;
import java.util.Timer;
import java.util.TimerTask;


public class HomeSwitchActivity extends Activity {
  private UsbSerialDriver mSerialDevice;
  private long rtcVerschil; // verschil in Android-tijd en RTC
  private int yyyy;
  private int MM;
  private int dd;
  private int hh;
  private int mm;
  private String hulp;
  private boolean serialOpen = false;
  private TextView tbxOp, tbxOnder, tbxRTC;
  private CheckBox chbAan, chbUit;
  private Spinner cmbBaud, cmbHuiscode, cmbAan, cmbUit, cmbOffset;

  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.main);
    UsbManager mUsbManager = (UsbManager) getSystemService(Context.USB_SERVICE);
    mSerialDevice = UsbSerialProber.acquire(mUsbManager);
    tbxOp = (TextView) findViewById(R.id.tbx1);
    tbxOnder = (TextView) findViewById(R.id.tbx2);
    tbxRTC = (TextView) findViewById(R.id.tbx3);
    chbAan = (CheckBox) findViewById(R.id.chbL1);
    chbUit = (CheckBox) findViewById(R.id.chbL2);
    cmbBaud = (Spinner) findViewById(R.id.cmb1);
    cmbHuiscode = (Spinner) findViewById(R.id.cmb2);
    cmbAan = (Spinner) findViewById(R.id.cmb3);
    cmbUit = (Spinner) findViewById(R.id.cmb4);
    cmbOffset = (Spinner) findViewById(R.id.cmb5);

    for (int i = 2; i <= 5; i++) {
      int id = getResources().getIdentifier("cmb".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
      Spinner cmb = (Spinner) findViewById(id);
      cmb.setEnabled(false);
    }
    TimerTask task = new TimerTask() {
      @Override
      public void run() {
        HomeSwitchActivity.this.runOnUiThread(new Runnable() {
          @Override
          public void run() {
            if (!tbxRTC.getText().equals("")) {
              Calendar nu = Calendar.getInstance();
              long t = nu.getTimeInMillis();
              nu.setTimeInMillis(t + rtcVerschil);
              SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm", Locale.GERMAN);
              tbxRTC.setText(simpleDateFormat.format(nu.getTime()));
            }
          }
        });
      }
    };
    Timer t = new Timer();
    t.scheduleAtFixedRate(task, 0, 30000);
  }

  @Override
  protected void onResume() {
    super.onResume();
    try {
      mSerialDevice.close();
    } catch (IOException e) {
    }
    serialOpen = false;
    onCreate(new Bundle());
  }

  public void leesCode() {
    if (!serialOpen) return;
    try {
      byte buffer[] = new byte[32];
      String serialInput = "";
      char c;
      boolean endln = false;
      while (!endln) {
        int numBytesRead = mSerialDevice.read(buffer, 100);
        for (int i = 0; i < numBytesRead; i++) {
          c = (char) buffer[i];
          if (c == '\n') {
            serialData(serialInput);
            endln = true;
          } else
            serialInput += (char) buffer[i];
        }
      }
    } catch (IOException e) {
      Toast.makeText(getBaseContext(), e.getMessage(), Toast.LENGTH_LONG).show();
    }
  }

  private void zendCode(String s) {
    if (!serialOpen) return;
    byte[] bytes = s.getBytes();
    try {
      mSerialDevice.write(bytes, 100);
      android.os.SystemClock.sleep(50);
      if (s.startsWith("K"))
        leesCode();
    } catch (IOException e) {
      Toast.makeText(getBaseContext(), e.getMessage(), Toast.LENGTH_LONG).show();
    }
  }

  public void ClickHandler(View v) {
    switch (v.getId()) {
      case R.id.btn2:
        if (mSerialDevice != null) {
          int baud = Integer.parseInt(cmbBaud.getSelectedItem().toString());
          try {
            mSerialDevice.open();
            mSerialDevice.setParameters(baud, 8, 1, 0);
            serialOpen = true;
            zendCode("K1\n");
            for (int i = 1; i <= 4; i++) {
              int id = getResources().getIdentifier("btn".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
              Button btn = (Button) findViewById(id);
              btn.setEnabled(!btn.isEnabled());
            }
            for (int i = 1; i <= 16; i++) {
              int id = getResources().getIdentifier("chb".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
              CheckBox chb = (CheckBox) findViewById(id);
              chb.setEnabled(!chb.isEnabled());
            }
            for (int i = 1; i <= 16; i++) {
              int id = getResources().getIdentifier("chbD" + Integer.toString(i), "id", "com.onkie.HomeSwitch");
              CheckBox chb = (CheckBox) findViewById(id);
              chb.setEnabled(!chb.isEnabled());
            }
            for (int i = 1; i <= 2; i++) {
              int id = getResources().getIdentifier("chbL".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
              CheckBox chb = (CheckBox) findViewById(id);
              chb.setEnabled(!chb.isEnabled());
            }
            for (int i = 1; i <= 5; i++) {
              int id = getResources().getIdentifier("cmb".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
              Spinner cmb = (Spinner) findViewById(id);
              cmb.setEnabled(!cmb.isEnabled());
            }
          } catch (IOException e) {
            Toast.makeText(getBaseContext(), e.getMessage(), Toast.LENGTH_LONG).show();
          }
        }
        break;
      case R.id.btn1:
        try {
          mSerialDevice.close();
          serialOpen = false;
          onCreate(new Bundle());
        } catch (IOException e) {
          Toast.makeText(getBaseContext(), e.getMessage(), Toast.LENGTH_LONG).show();
        }
        break;
      case R.id.btn3:
        laden();
        break;
      case R.id.btn4:
        update();
        break;
    }
  }

  private void update() { // Arduino updaten
    Calendar nu = Calendar.getInstance();
    SimpleDateFormat simpleDateFormat = new SimpleDateFormat("dd", Locale.GERMAN);
    zendCode("U01" + simpleDateFormat.format(nu.getTime()) + "\n");
    simpleDateFormat = new SimpleDateFormat("MM", Locale.GERMAN);
    zendCode("U02" + simpleDateFormat.format(nu.getTime()) + "\n");
    simpleDateFormat = new SimpleDateFormat("yy", Locale.GERMAN);
    zendCode("U03" + simpleDateFormat.format(nu.getTime()) + "\n");
    simpleDateFormat = new SimpleDateFormat("HH", Locale.GERMAN);
    zendCode("U04" + simpleDateFormat.format(nu.getTime()) + "\n");
    simpleDateFormat = new SimpleDateFormat("mm", Locale.GERMAN);
    zendCode("U05" + simpleDateFormat.format(nu.getTime()) + "\n");
    simpleDateFormat = new SimpleDateFormat("ss", Locale.GERMAN);
    zendCode("U06" + simpleDateFormat.format(nu.getTime()) + "\n");
    String s = "";
    for (int i = 1; i <= 16; i++) {
      int id = getResources().getIdentifier("chb".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
      CheckBox chb = (CheckBox) findViewById(id);
      s += chb.isChecked() ? "1" : "0";
    }
    String bewaar = s + ";";
    zendCode("U07" + s + "\n");
    s = "";
    for (int i = 1; i <= 16; i++) {
      int id = getResources().getIdentifier("chbD".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
      CheckBox chb = (CheckBox) findViewById(id);
      s += chb.isChecked() ? "1" : "0";
    }
    bewaar += s + ";";
    zendCode("U08" + s + "\n");
    for (int i = 1; i <= 4; i++) {
      int id = getResources().getIdentifier("cmb".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
      Spinner cmb = (Spinner) findViewById(id);
      zendCode("U0".concat(Integer.toString(i + 8)) + cmb.getSelectedItem().toString() + "\n");
    }
    zendCode("U09" + cmbOffset.getSelectedItem().toString() + "\n");
    zendCode("U10" + (chbAan.isChecked() ? "1" : "0") + "\n");
    zendCode("U11" + (chbUit.isChecked() ? "1" : "0") + "\n");
    zendCode("U12" + cmbAan.getSelectedItem().toString().substring(0, 2) + "\n");
    zendCode("U13" + cmbAan.getSelectedItem().toString().substring(3) + "\n");
    zendCode("U14" + cmbUit.getSelectedItem().toString().substring(0, 2) + "\n");
    zendCode("U15" + cmbUit.getSelectedItem().toString().substring(3) + "\n");
    zendCode("U16" + cmbHuiscode.getSelectedItem().toString() + "\n");
    bewaar += cmbOffset.getSelectedItem().toString() + ";" +
        (chbAan.isChecked() ? "1" : "0") + ";" +
        (chbUit.isChecked() ? "1" : "0") + ";" +
        cmbAan.getSelectedItem().toString().substring(0, 2) + ";" +
        cmbAan.getSelectedItem().toString().substring(3) + ";" +
        cmbUit.getSelectedItem().toString().substring(0, 2) + ";" +
        cmbUit.getSelectedItem().toString().substring(3) + ";" +
        cmbHuiscode.getSelectedItem().toString();
    File extDir = Environment.getExternalStorageDirectory();
    try {
      FileWriter out = new FileWriter(new File(extDir, "HomeSwitch.dat"));
      out.write(bewaar);
      out.close();
      Toast.makeText(getBaseContext(), "'HomeSwitch.dat' >> SD", Toast.LENGTH_SHORT).show();
    } catch (IOException e) {
      Toast.makeText(getBaseContext(), "FOUT: Kan 'HomeSwitch.dat' niet opslaan!", Toast.LENGTH_LONG).show();
    }
  }

  private void serialData(String s) {
    int j = s.indexOf("K");
    String k = s.substring(0, ++j); // opdracht
    s = s.substring(j); // waarde
    if (k.equals("1K")) { // opdracht 1K, waarde huiscode....
      cmbHuiscode.setSelection(setCmb(R.array.cmbHuiscode, s));
      zendCode("K2\n");
    } else if (k.equals("2K")) {
      yyyy = Integer.parseInt(s);
      zendCode("K3\n");
    } else if (k.equals("3K")) {
      MM = Integer.parseInt(s);
      zendCode("K4\n");
    } else if (k.equals("4K")) {
      dd = Integer.parseInt(s);
      zendCode("K5\n");
    } else if (k.equals("5K")) {
      hh = Integer.parseInt(s);
      zendCode("K6\n");
    } else if (k.equals("6K")) {
      mm = Integer.parseInt(s);
      zendCode("K7\n");
    } else if (k.equals("7K")) {
      int ss = Integer.parseInt(s);
      Calendar dt = Calendar.getInstance();
      dt.set(yyyy, MM, dd, hh, mm, ss);
      Calendar nu = Calendar.getInstance();
      rtcVerschil = nu.getTimeInMillis() - dt.getTimeInMillis();  // verschil in tijd bewaren
      SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm");
      tbxRTC.setText(simpleDateFormat.format(dt.getTime()));
      zendCode("K8\n");
    } else if (k.equals("8K")) {
      for (int i = 1; i <= 16; i++) {
        int id = getResources().getIdentifier("chb".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
        CheckBox chb = (CheckBox) findViewById(id);
        setCheck(chb, s.substring(i - 1, i));
      }
      zendCode("K9\n");
    } else if (k.equals("9K")) {
      for (int i = 1; i <= 16; i++) {
        int id = getResources().getIdentifier("chbD".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
        CheckBox chb = (CheckBox) findViewById(id);
        setCheck(chb, s.substring(i - 1, i));
      }
      zendCode("K10\n");
    } else if (k.equals("10K")) {
      String l = s.length() == 1 ? "0" : "";
      hulp = l + s + ":";
      zendCode("K11\n");
    } else if (k.equals("11K")) {
      String l = s.length() == 1 ? "0" : "";
      hulp += l + s;
      tbxOp.setText(hulp);
      zendCode("K12\n");
    } else if (k.equals("12K")) {
      String l = s.length() == 1 ? "0" : "";
      hulp = l + s + ":";
      zendCode("K13\n");
    } else if (k.equals("13K")) {
      String l = s.length() == 1 ? "0" : "";
      hulp += l + s;
      tbxOnder.setText(hulp);
      zendCode("K14\n");
    } else if (k.equals("14K")) {
      cmbOffset.setSelection(setCmb(R.array.cmbOffset, s));
      zendCode("K15\n");
    } else if (k.equals("15K")) {
      setCheck(chbAan, s);
      zendCode("K16\n");
    } else if (k.equals("16K")) {
      setCheck(chbUit, s);
      zendCode("K17\n");
    } else if (k.equals("17K")) {
      String l = s.length() == 1 ? "0" : "";
      hulp = l + s + ":";
      zendCode("K18\n");
    } else if (k.equals("18K")) {
      String l = s.length() == 1 ? "0" : "";
      hulp += l + s;
      cmbAan.setSelection(setCmb(R.array.cmbAan, hulp));
      zendCode("K19\n");
    } else if (k.equals("19K")) {
      String l = s.length() == 1 ? "0" : "";
      hulp = l + s + ":";
      zendCode("K20\n");
    } else if (k.equals("20K")) {
      String l = s.length() == 1 ? "0" : "";
      hulp += l + s;
      cmbUit.setSelection(setCmb(R.array.cmbUit, hulp));
    }
  }

  private void laden() {
    File extDir = Environment.getExternalStorageDirectory();
    try {
      BufferedReader br = new BufferedReader(new FileReader(new File(extDir, "HomeSwitch.dat")));
      String line;
      String s = "";
      while ((line = br.readLine()) != null) {
        s += line;
      }
      br.close();
      String ar[] = s.split(";");
      for (int i = 1; i <= 16; i++) {
        int id = getResources().getIdentifier("chb".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
        CheckBox chb = (CheckBox) findViewById(id);
        setCheck(chb, ar[0].substring(i - 1, i));
      }
      for (int i = 1; i <= 16; i++) {
        int id = getResources().getIdentifier("chbD".concat(Integer.toString(i)), "id", "com.onkie.HomeSwitch");
        CheckBox chb = (CheckBox) findViewById(id);
        setCheck(chb, ar[1].substring(i - 1, i));
      }
      cmbOffset.setSelection(setCmb(R.array.cmbOffset, ar[2]));
      setCheck(chbAan, ar[3]);
      setCheck(chbUit, ar[4]);
      String l = ar[5].length() == 1 ? "0" : "";
      hulp = l + ar[5] + ":";
      l = ar[6].length() == 1 ? "0" : "";
      hulp += l + ar[6];
      cmbAan.setSelection(setCmb(R.array.cmbAan, hulp));
      l = ar[7].length() == 1 ? "0" : "";
      hulp = l + ar[7] + ":";
      l = ar[8].length() == 1 ? "0" : "";
      hulp += l + ar[8];
      cmbUit.setSelection(setCmb(R.array.cmbUit, hulp));
      cmbHuiscode.setSelection(setCmb(R.array.cmbHuiscode, ar[9]));
    } catch (IOException e) {
      Toast.makeText(getBaseContext(), e.getMessage(), Toast.LENGTH_LONG).show();
    }
  }

  int setCmb(int cmb, String s) {
    ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(this, cmb, android.R.layout.simple_spinner_item);
    return adapter.getPosition(s);
  }


  private void setCheck(CheckBox chb, String s) {
    boolean c = false;
    if (s.equals("1")) c = true;
    chb.setChecked(c);
  }
}