/******************************************
 ***** communicatie met PC of Android *****
 ******************************************/
#ifdef CLIENT
void serialEvent()
{  // USB interrupt: leest een met LF afgesloten string in 
  while (Serial.available())
  {
    char inChar = (char)Serial.read(); 
    if (inChar == '\n')
    {  // LF ontvangen = einde opdracht code
      if (sInput.startsWith("K")) verzendKaKuScreen(sInput.substring(1));  // verzoek om 'K1' t/m 'K20' instellingen verzenden
      else if (sInput.startsWith("U")) setUpdate(sInput.substring(1)); // 'U01...' t/m 'U16...' update ontvangen
      sInput = "";  // buffer legen, klaar voor volgende opdracht
    } 
    else sInput += inChar;  // teken aan buffer toevoegen
  }
}

byte dd, MM, yy, hh, mm;
void setUpdate(String s)
{  // update van af PC/Android/Serial monitor uitvoeren
  String sn = s.substring(0, 2);
  byte n = sn.toInt();
  s = s.substring(2); 
  switch (n)
  {
  case 1: 
    dd = s.toInt();
    break;
  case 2: 
    MM = s.toInt();
    break;
  case 3: 
    yy = s.toInt();
    break;
  case 4: 
    hh = s.toInt();
    break;
  case 5: 
    mm = s.toInt();
    break;
  case 6: 
    {
      byte ss = s.toInt(); //strToI(s);
      setTime(TD.calcTimeStamp(hh, mm, ss, dd, MM, yy) - localTimeOffset);
      RTC.set(now());  // RTC en system tijd instellen, UTC!!!
    }
    break;
  case 7: 
    for (byte i = 0; i < 16; i++)
    {
      sn = s.substring(i, i + 1);
      ontvangers[SCHAKEL][i] = sn.toInt();
    }
    break;
  case 8: 
    for (byte i = 0; i < 16; i++) 
    {
      sn = s.substring(i, i + 1);
      ontvangers[DIMMER][i] = sn.toInt();
    }
    break;
  case 9: 
    zonOffset = s.toInt(); 
    break;
  case 10: 
    ochtend = s.toInt(); 
    break;
  case 11: 
    avond = s.toInt(); 
    break;
  case 12: 
    aanUur = s.toInt(); 
    break;
  case 13: 
    aanMinuut = s.toInt(); 
    break; 
  case 14: 
    uitUur = s.toInt(); 
    break;
  case 15: 
    uitMinuut = s.toInt(); 
    break;
  case 16: 
    huisCode = s.charAt(0);
    schrijfEEPROM();  // dit was de laatste, dus ook EEPROM updaten
    initKaKu(false);  // aan nieuwe instellingen aanpassen 
  }
}

void verzendKaKuScreen(String s)
{  // instellingen naar PC/Android sturen
  Serial << s + "K";  // beging met opdrachtcode 's'+'K' (1K, 2K,.... 20K)
  switch (s.toInt())
  {
  case 1: 
    Serial << huisCode; 
    break;
  case 2: 
    Serial << year(localTime); 
    break;
  case 3: 
    Serial << month(localTime); 
    break;
  case 4: 
    Serial << day(localTime); 
    break;
  case 5: 
    Serial << hour(localTime); 
    break;
  case 6: 
    Serial << minute(localTime); 
    break;
  case 7: 
    Serial << second(localTime); 
    break;
  case 8:
    for (byte i = 0; i < 16; i++) Serial << ontvangers[SCHAKEL][i];
    break;
  case 9:
    for (byte i = 0; i < 16; i++) Serial << ontvangers[DIMMER][i];
    break;
  case 10: 
    Serial << TD.sunRiseHour; 
    break;
  case 11: 
    Serial << TD.sunRiseMinute; 
    break;
  case 12: 
    Serial << TD.sunSetHour; 
    break;
  case 13: 
    Serial << TD.sunSetMinute; 
    break;
  case 14: 
    Serial << zonOffset; 
    break;
  case 15: 
    Serial << ochtend; 
    break;
  case 16: 
    Serial << avond; 
    break;
  case 17: 
    Serial << aanUur; 
    break;
  case 18: 
    Serial << aanMinuut; 
    break;
  case 19: 
    Serial << uitUur; 
    break;
  case 20: 
    Serial << uitMinuut;
  }
  Serial << "\n";
}

#endif