/********************
 ***** LCD 4x20 *****
 ********************/

#ifdef LCD
void toonDatumTijd()
{
  // datum en tijd naar LCD
  String weekdagen[7] = {"zo", "ma", "di", "wo", "do", "vr", "za"  };
  char zomerWinter = 'w';  // voor LCD: w=winter 
  if (TD.isDst) zomerWinter = 'z';  // voor LCD: z=zomer
  // dag, datum en tijd naar LCD
  lcd.setCursor(0, 0);  // begin op positie 1 (0), regel 0 (0)
  lcd << weekdagen[weekday(localTime) - 1] << " " << fD(day(localTime), "002") << '-'
    << fD(month(localTime), "002") << '-' << year(localTime) << ' ' 
    << fD(hour(localTime), "002") << ':' << fD(minute(localTime), "002") << zomerWinter;
}

void toonLampMode()
{
  // KaKu is in mode: Auto of Aan of Uit of Stop
  String mode[4] = {"Auto", "Aan", "Uit", "Stop"  };
  lcd.setCursor(0, 1);
  lcd.write(2);  // lamp
  lcd << fS(mode[knopWaarde[KNOP_1]], "- 4");
  lcd.setCursor(0, 3);
  char aanUit = '-';
  if (lampenZijnAan) aanUit = '+';
  lcd << aanUit;
  for (byte i = 0; i < 15; i += 4) 
  {
    for (byte j = 0; j < 4; j++) lcd << ontvangers[SCHAKEL][i + j];
    if (i < 12) lcd << ' ';
  }
}

void toonZonMaan() 
{
  lcd.setCursor(7, 1);
  lcd.write(0);  // zon
  lcd << fD(TD.sunRiseHour, "002") << ':' << fD(TD.sunRiseMinute, "002");
  lcd.setCursor(14, 1);
  lcd.write(1);  // maan
  lcd << fD(TD.sunSetHour, "002") << ':' << fD(TD.sunSetMinute, "002");
}

#ifdef SCREEN
void toonScreenMode() 
{
  // screen is in mode: Auto of Neer of Op of Stop
  String mode[4] = {"Auto", "Neer", "Op", "Stop"  };
  lcd.setCursor(0, 2);
  lcd.write(3);  // screen
  lcd << fS(mode[knopWaarde[KNOP_2]], "- 4");
}

void toonTemp() 
{
  lcd.setCursor(7, 2);
  lcd.write(4);  // temp
  lcd << fD(temp, " 14");
  lcd.write(6);  // graad
}

void toonLux() 
{
  lcd.setCursor(14, 2);
  lcd.write(5);  // licht
  lcd << fD(lux, " 05");
}

void toonOpNeer()
{
  lcd.setCursor(5, 2);
  char opNeer = '-';
  if(screenIsNeer) opNeer = '+';
  lcd << opNeer;
}
#endif
#endif


