/***********************************************************************************
 ***** Licht, screen, gordijnen en andere voorzieningen worden hier geschakeld *****
 ***********************************************************************************/

void lampenUit()
{
  for (byte i = 0; i < 16; i++) 
    if (ontvangers[SCHAKEL][i])
    { 
      kaKuTransmitter.sendSignal(huisCode, i + 1, false);  // KaKu-knop begint bij 1, dus nummer + 1
      delay(500);  // even de tijd geven voor de volgende er aan komt
    }
  digitalWrite(13, LOW);  // Arduino LED-13 uit
  lampenZijnAan = false;  // lamp-flag uit
}

void lampenAan()
{
  if (!lampenZijnAan)  // alleen als lampen uit zijn
      for (byte i = 0; i < 16; i++)
      if (ontvangers[SCHAKEL][i] == 1)
      { // lamp doet mee
        if (ontvangers[DIMMER][i])
        {
          kaKuTransmitter.sendSignal(huisCode, i + 1, false);  // KaKu-knop begint bij 1, dus i + 1
          delay(500);  // even de tijd geven voor de volgende er aan komt
        }
        kaKuTransmitter.sendSignal(huisCode, i + 1, true); 
        delay(500); 
      }
  digitalWrite(13, HIGH);  // Arduino LED-13 aan
  lampenZijnAan = true;  // lamp-flag aan
}

#ifdef SCREEN
/* screens met RF-AB: met optocouplers en 2 knops AB
 * de schakelaars van de AB worden overbrucht met een optocoupler 
 * Screen heeft 2 opdrachten nodig, 1e is stop vorige en 2e is de nieuwe opdracht
 * als de vorige geen stop behoefd dan reageerd het screen direct en heeft de 2e geen invloed
 ****** screens zonder RF-AB bedien je m.b.v. een KaKu zonweringontvanger ("#define KAKU" aanzetten) ******/
void screenNeerOP()
{
  if (knopWaarde[KNOP_2] == 0) 
    if (screenIsNeer)
    {
      if (screenTemp == false || screenLux == false)
      {  // ophalen?
#ifndef KAKU  // optocoupler of KaKu (LET OP de 'n' in #ifndef die staat voor "if NOT define")  
        screenOpto(optoPinOp);
#else  // KaKu ***** code en knop bij HomeSwitch.ino invullen ***** 
        screenKaKu(false);  
#endif
        screenIsNeer = false;
      }
    }
    else {
      if (screenTemp == true && screenLux == true)
      {  // neerlaten?
#ifndef KAKU  // optocoupler of KaKu       
        screenOpto(optoPinNeer); 
#else  // KaKu ***** code en knop bij HomeSwitch.ino invullen *****
        screenKaKu(true);  
#endif
        screenIsNeer = true;
      }
    }
}

#ifndef KAKU  // optocoupler of KaKu
void screenOpto(byte pin) 
{
  boolean HighLow = true;
  for (byte i = 0; i < 4; i++)
  {
    digitalWrite(pin, HighLow); 
    delay(500);
    HighLow = !HighLow;
  }
}
#else
void screenKaKu(boolean aan)
{  // KaKu ***** code en knop bij HomeSwitch.ino invullen *****
  kaKuTransmitter.sendSignal(huisCodeScreen, kakuKnopScreen, aan);  
}
#endif
#endif

#ifdef GORDIJN
/* met een KaKu-code een KaKu zonweringontvanger of door een 2e Arduino aan te sturen
 * gaat niet met lampenUit()/lampenAan() omdat Aan/Uit hier omgekeerd werkt
 * naast bestaande oplossingen kan ook eenvoudig een servo 180 (lamellen 1/4 slag draaien),
 *360 servo of steppermotor worden aangestuurd */
void gordijnOpen()
{  // zon komt op
  kaKuTransmitter.sendSignal(huisCodeGordijn , kakuKnopGordijn , false);  // gordijn open
}

void gordijnDicht() 
{  // zon gaat onder
  kaKuTransmitter.sendSignal(huisCodeGordijn , kakuKnopGordijn , true);  // gordijn dicht
  // kaKuTransmitter.sendSignal(kakuKnopZonwering , kakuKnopGordijn , false);  // zonwering ophalen???
}
#endif




