#ifdef SDCARD

FATFS FatFs;  // Work area (file system object) for logical drive
SdFatFs sdFatFs;  // SD FatFs class
FIL fil;  // File object
SdSpi sdSpi;  // SD SS pin
FRESULT fr;  // FatFs return code
boolean saveSdOpen = false;

void testSD()
{
  sdSpi.pinSS(SpiSsPin);  // SD Select pin
  // test if memory card is inserted
  sdFatFs.f_mount(&FatFs, "", 0);
  if (!sdFatFs.f_open(&fil, "hs.ini", FA_OPEN_EXISTING | FA_READ))
  {
    if (!saveSdOpen)
    {  // first time or new card is inserted 
      getWaarden();
      saveSdOpen = true;
    }
  }
  else
  {
    saveSdOpen = false;
  }
}

void getWaarden()
{
  String str = readFile();
  if (str.length() > 16)
  {
    for (byte i = 0; i < 16; i++)
      ontvangers[SCHAKEL][i] = str.substring(i, i + 1).toInt();
    str = readFile();
    if (str.length() > 16)
    {
      for (byte i = 0; i < 16; i++)
        ontvangers[DIMMER][i] = str.substring(i, i + 1).toInt();
      str = readFile();
      if (str.length() > 2)
      {
        zonOffset = str.toInt(); 
        str = readFile();
        if (str.length() > 1)
        {
          ochtend = str.toInt(); 
          str = readFile();
          if (str.length() > 1)
          {
            avond = str.toInt(); 
            str = readFile();
            if (str.length() > 2)
            {
              aanUur = str.toInt(); 
              str = readFile();
              if (str.length() > 2)
              {
                aanMinuut = str.toInt(); 
                str = readFile();
                if (str.length() > 2)
                {
                  uitUur = str.toInt(); 
                  str = readFile();
                  if (str.length() > 2)
                  {
                    uitMinuut = str.toInt(); 
                    str = readFile();
                    if (str.length() > 1)
                    {
                      huisCode = str.toInt(); 
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
  sdFatFs.f_close(&fil);  // Close file
  schrijfEEPROM();  // dit was de laatste, dus ook EEPROM updaten
  initKaKu(false);  // aan nieuwe instellingen aanpassen 
}

String readFile()
{
  char line[32];  // Line buffer
  if (sdFatFs.f_gets(line, sizeof(line), &fil))  // lees n regel in
  {
    return line;
  }
  return "";
}

#endif

